/* A P1.2 bemenetre kotott gomb megnyomasakor (lefuto el) valtozzon
   a P3.5 kimenetre kotott lampa allapota. A kimenet valtozasahoz
   szukseges gombnyomasok szamat a P1.4-P1.5 bemeneteken allitjuk
   be (2 bites binaris szam)
*/

#include "hw.h"

bit elozo;		/* Bemenet elozo allapota */
bit dummy;		/* IAR4 Fordito hibaja miatt... */
char szamlalo;		/* Gombnyomasok szamlaloja */
char mennyit;		/* Mennyit kell nyomni a valtashoz */

#if defined SDCC || defined __SDCC
#define BE P1_2
#define KI P3_5
#elif defined __C51__
sbit BE= P1^2;
sbit KI= P3^5;
#else
#define BE P1.2
#define KI P3.5
#endif

void main(void)
{
  BE= 1;	/* Bemenet legyen */
  elozo= BE;	/* A tovabi osszehasonlitashoz elmentjuk */
  KI= 0;	/* Kimenet kezdoerteke */
  szamlalo= 0;	/* Eddig ennyi megnyomas volt */
  for (;;)
    {
      /* A bemenet aktualis erteket az elmentetthez hasonlitjuk */
      if (elozo==BE)
	{
	  /* egyezik: nem valtozott */
	}
      else
	{
	  /* valtozott */
	  elozo= BE; /* Tovabbiakban ezzel hasonlitunk */
	  /* Az aktualis ertek vizsgalataval eldontjuk
	     a bemenet mirol mire valtozott */
	  if (BE)
	    {
	      /* 0->1 valtozas: elengedes */
	      /* Semmi teendo... */
	    }
	  else
	    {
	      /* 1->0 valtozas: megnyomas */
	      /* Szamoljuk a megnyomasokat */
	      szamlalo++;
	      /* Megnezzuk mennyit kell nyomni */
	      mennyit= (P1>>4) & 3;
	      if (mennyit && szamlalo>=mennyit)
		{
		  /* Megnyomas szamlalo alaphelyzetbe */
		  szamlalo= 0;
		  /* Kimenet valtoztatas */
		  KI= !KI;
		}
	    }
	}
    }
}

