#include "f020.h"
#include "analog.h"

void
analog_select(unsigned int ch)
{
	//int i;
	if (AMX0SL!=ch)
	{
		AMX0SL= ch;
		for (ch=0;ch<10000;ch++) ;
	}
}

void
analog_init(int ch)
{
	AMX0CF= 0;
	analog_select(ch);
	ADC0CF= 0x08 | 0x00;
	REF0CN= 0x07;
	AD0EN= 1;
}

int
analog()
{
	int i;
	AD0INT= 0;
	AD0BUSY= 1;
	i= 0;
	while (!AD0INT && i<10000)
		i++;
	return AD0INT?(ADC0H*256 + ADC0L):0;
}

int
analog_p()
{
	int i= analog();
	return ((float)i/4096.0)*100.0;
}

float
temperature()
{
	long int i;
 	float f;

	analog_select(8);
	i= analog();
	
	f= i * 3.3/4096.0;
	return (f-0.776)/0.00286;
}

