#include "f380.h"
#include "fx.h"

//#pragma codeseg  SILABS_CODE
//#pragma constseg SILABS_CONST


enum t_br used_br;
unsigned char used_clk;

const long
#if defined __C51__
code
#endif
br_table[]= {
  0, // 0
  110, // 1
  150, // 2
  300, // 3
  600, // 4
  1200, // 5
  2400, // 6
  4800, // 7
  9600, // 8
  19200, // 9
  38400, // 10
  57600, // 11
  115200, // 12
  0
};


#define STBI struct t_board_info
const struct t_board_info *
get_board_info()
{
    /*__code struct t_board_info * */ CODE_PTR(STBI)bi=
	(/*__code struct t_board_info * */CODE_PTR(STBI))BOARD_INFO;

    if (bi->magic_sign == MAGIC_SIGN)
	return bi;
  
    for (bi= (/*__code struct t_board_info * */CODE_PTR(STBI))(0x1000 - RESERVED_SPACE);
	 bi > (/*__code struct t_board_info * */CODE_PTR(STBI))(0x10000 - RESERVED_SPACE - (2*PAGE_SIZE));
	 bi= (/*__code struct t_board_info * */CODE_PTR(STBI))(((/*__code char * */CODE_PTR(char))bi) - INFO_BLOCK_SIZE)
	)
	if (bi->magic_sign == MAGIC_SIGN)
	    return bi;
    
    return 0;
}

long
get_Fosc()
{
    return 12000000*3;
}


void
br_init(enum t_br br)
{
    unsigned int r;
  
    TR2= 0;
    if (br!=BR_0)
    {
	r= 65536-(get_Fosc()/(32*br_table[br]));
	RCAP2L= r&0xff;
	RCAP2H= r/256;
	TL2= RCAP2L;
	TH2= RCAP2H;
	TR2= 1;
    }
    used_br= br;
}

void
Port_IO_Init()
{
    P1MDIN    = 0xDF;
    P0MDOUT   = 0x31;
    P4MDOUT   = 0xF0;
    P1SKIP    = 0x20;
    XBR0      = 0x09;
    XBR1      = 0x40;
}

void
oscillator_init(enum t_osc osc)
{
    OSCICN= 0xC3;
}


#if defined __SDCC || defined SDCC
static __sfr __at(0x97) s97;
#elif defined __C51__
static sfr s97= 0x97;
#endif

unsigned char board= 0, rst_reason= 0;

void
f380_init(void)
{
    /*__code unsigned char * */CODE_PTR(unsigned char)boot_loader= (/*__code unsigned char * */CODE_PTR(unsigned char))LOADER_START;
    void (*reprogram)();

    rst_reason= RSTSRC;

    /* WDT disable */
    PCA0MD    &= ~0x40;
    PCA0MD    = 0x00;

    /* Port */
    Port_IO_Init();
    
    /* Osciccaltor */
    oscillator_init(0);
    
    /* Timer */
    TMOD= 0x20;
    CKCON= 0x01;
    TH1= 0x64;

    /* ITx mapping */
    IT01CF= 0x23;
    //P0SKIP= 0x0c;
    
    reprogram= (void(*)())LOADER_START;
    if ((P3 & 0x1c) == 0)
	reprogram();
}


#if defined __SDCC || defined SDCC
void dummy_isr(void) __interrupt(6)
#elif defined __C51__
/*void ext0_isr(void)*/
#else /* IAR4 */
/*interrupt void EXT0_int(void)*/
#endif
{
}

/* End of f380.c */

/* Local variables: */
/* c-file-style: "linux" */
/* c-basic-offset: 4 */
/* End: */
