#include "hw.h"

#if defined __SDCC || defined SDCC
#include <stdio.h>
#endif

#include "sernoi.h"

//#pragma codeseg  SERNOI_CODE
//#pragma constseg SERNOI_CONST

volatile __bit serial_sent;


/* Initialization of serial line */

void
serial_init(long int br)
{
  /* Set  variables */
  if (!(serial_sent= 1))
    serial_dummy();

  /* Set Timer2 as baudrate generator, XTAL=11.0592MHz */
  C_T2= 0;
  CP_RL2= 0;
  {
    long int l= (3*115200)/br;
    TL2= RCAP2L= (65536-l)&0xff; /* 3=115200,6=57600,9=38400,18=19200,36=9600 */
    TH2= RCAP2H= (65536-l)/256;
  }
  RCLK= 1;
  TCLK= 1;
  TR2= 1;
  
  /* Set USART mode: 8 bit variable speed */
  SCON= 0x40;
  ES= 0;
  REN= 1;
}


void
f380_serial_init(void)
{
/*
  if (first_occupied= 0)
  ;
  first_free= 0;
  serial_sent= 1;
*/
  if (!(serial_sent= 1))
    serial_dummy();

  TMOD= (TMOD & 0x0f) + 0x20;
  PCON&= 0x7f;
  ET1= 0;
  
  SCON= 0x40;
  ES= 1;
  REN= 1;
  
  TR1= 1;
  //EA= 1;
}



/************************************************** Low level line handling */

/* Blocking send */

unsigned char
serial_send(unsigned char c)
{
  	SBUF= c;
	while (!TI) ;
	TI= 0;
  	return c;
}

int
putchar(int c)
{
  return serial_send(c);
}


/* Check for recived chars */

unsigned char
serial_received(void)
{
  return RI?1:0;
}


/* Blocking receive */

unsigned char
serial_receive(void)
{
  while (!serial_received()) ;
  RI= 0;
  return SBUF;
}

char
getchar(void)
{
  return serial_send(serial_receive());
}


/*********************************************** High level print functions */

void
serial_dummy(void)
{
  serial_init(0);
  serial_send(0);
  serial_received();
  putchar(0);
  getchar();
}


/* End of serial.c */
