#include "hw.h"
#include "fx.h"
#include "t0.h"
#include "silprell.h"
#include "timer.h"

volatile bit btn5, btn4, btn3, btn2;

#if defined SDCC || defined __SDCC
#define BTN5 P3_5
#define BTN4 P3_4
#define BTN3 P3_3
#define BTN2 P3_2
#elif defined __C51__
sbit BTN5= P3^5;
sbit BTN4= P3^4;
sbit BTN3= P3^3;
sbit BTN2= P3^2;
#else /* IAR4 */
#define BTN5 P3.5
#define BTN4 P3.4
#define BTN3 P3.3
#define BTN2 P3.2
#endif

static volatile unsigned char t0l, t0h;
static volatile unsigned int cnt0= 0;
static volatile unsigned char pre_cnt= 0;

volatile unsigned char cnt100= 0;

#if defined __SDCC || defined SDCC
void t0_isr(void) __interrupt (1)
#elif defined __C51__
void T0_int(void) interrupt 1
#else /* IAR4 */
interrupt void T0_int(void)
#endif
{
	P3_0= !P3_0;
	TH0= t0h;
	TL0= t0l;
	if (++cnt0 >= DEBOUNCE_TIME)
	{
		btn5= BTN5;
		btn4= BTN4;
		btn3= BTN3;
		btn2= BTN2;
		cnt0= 0;
	}
	if (++pre_cnt > 10)
	{
		pre_cnt= 0;
		if (cnt100)
			cnt100--;
	}
}

void
debounce(void)
{
	unsigned int i= 0, t0reload;
	Fosc= (float)get_Fosc()/1000000.0;
	t0reload= T0kezdoertek(1.0);
	T0idozito1(0);
	T0beallit(t0reload);
	t0l= t0reload&0xff;
	t0h= t0reload/256;
	btn5= BTN5;
	btn4= BTN4;
	btn3= BTN3;
	btn2= BTN2;
	EA= 1;
	ET0= 1;
	T0start();
}
