#include <io51.h>
#include "sps.h"

/*static*/ char soros_buffer[SOROS_BUFFER_MERET];
/*static*/ char elso_foglalt, elso_szabad;
static bit kikuldve, dummy_bit;

interrupt void SCON_int(void)
{
	if (RI)
	{
		char uj= elso_szabad+1;
		uj= uj % SOROS_BUFFER_MERET;
		if (uj != elso_foglalt)
		{
			soros_buffer[elso_szabad]= SBUF;
			elso_szabad= uj;
		}
		RI= 0;
	}
	else if (TI)
	{
		kikuldve= 1;
		TI= 0;
	}
}

void
beallitas(void)
{
	/* Valtozok beallitasa */
	elso_foglalt= 0;
	elso_szabad= 0;
	kikuldve= 1;

	/* Timer1 beallitasa 9600 baud-os sebesseg generalasahoz */
	TMOD= (TMOD & 0x0f) | 0x20;
	TH1= 0xfd;
	TL1= 0xfd;
	PCON&= 0x7f; /* SMOD=0 */
	ET1= 0;

	/* Soros vonal beallitasa, 8 bites valtoztathato sebessegu mod */
	SCON= 0x40;
	ES= 1;
	REN= 1;

	/* Start */
	TR1= 1;	/* Idozito indul */
	EA= 1;	/* Megszakitasok engedelyezese */
}

void
putchar(char c)
{
	while (!kikuldve) ;
	SBUF= c;
	kikuldve= 0;
}

bool
vetel_volt(void)
{
	return(elso_szabad != elso_foglalt);
}

char
vett(void)
{
	char c;
	
	while (!vetel_volt()) ;
	ES= 0;
	c= soros_buffer[elso_foglalt];
	elso_foglalt++;
	elso_foglalt= elso_foglalt % SOROS_BUFFER_MERET;
	ES= 1;	
	return(c);
}

char
getchar(void)
{
	char c;
	
	c= vett();
	kikuld(c);
	if (c == '\r')
		return('\n');
	return(c);
}


/* End of soros.c */

/* Local variables: */
/* c-file-style: "linux" */
/* End: */
