TEST=""
S51v5=s515
S51v6=s516
VER=5
S51=$S51v5

PROF=""

while [ -n "$1" ]; do
    case "$1" in
	-6)
	    S51=$S51v6
	    VER=6
	    shift
	    ;;
	-5)
	    S51=$S51v5
	    VER=5
	    shift
	    ;;
	-p)
	    PROF="p"
	    shift
	    ;;
	-P)
	    shift
	    TEST="$1"
	    CMD="gprof ${S51}p st${TEST}_v${VER}_gmon.out"
	    echo $CMD
	    $CMD
	    exit 0
	    ;;
	*)
	    TEST="$1"
	    shift
	    ;;
    esac
done

if [ -n "$PROF" ]; then
    S51=${S51}p
fi

echo -e "*\n* st${TEST}\n*\n"

SIM=st${TEST}${VER}.sim
OUT=st${TEST}${VER}.out
TIM=st${TEST}${VER}.tim

/usr/bin/time -o $TIM -f '
Elapsed\t%e
Kernel\t%S
User\t%U
In\t%I
Out\t%O
SwT\t%c
SwIO\t%w
MajFlt\t%F
MinFlt\t%R
Swaps\t%W
Mem\t%M
Unshr\t%D
' $S51 -tC52 -Sin=/dev/null,out=$OUT st${TEST}.ihx <st.cmd|tee $SIM
tee -a $SIM <$TIM

if [ -n "$PROF" ]; then
    mv gmon.out st${TEST}_v${VER}_gmon.out
fi

E=$(grep Elapsed $SIM)
#echo
#echo $E

E=$(echo $E|cut -d ' ' -f 2)
C=$(grep 'Total time' $SIM|sed 's/^[^(]*(//'|sed 's/ .*//')
S=$(echo "scale=3;${C}/${E}/1000000"|bc)

echo "Speed= $S Mclk/sec"|tee -a $SIM
